=== debian/changelog ===
ipu6-camera-hal (0~git202501070628.8346d93~ubuntu24.04.2) noble; urgency=low

  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Fri, 24 Jan 2025 01:31:14 +0000

ipu6-camera-hal (0~git202411151015.7527bcc-1) UNRELEASED; urgency=medium

  [ Kai-Chuan Hsieh ]
  * debian: Add transitional package for ipu6ep series
  * debian: Add libcamhal-ipu6ep-common.preinst script to remove contents
  * Add modalias for IPU controllers
  * debian: Add support for LNL platform
  * debian: Add support for ARL platforms

  [ Shih-Yuan Lee (FourDollars) ]
  * debian: Fix a typo.
  * debian: Refactor to adopt the main branch.

 -- Shih-Yuan Lee (FourDollars) <sylee@canonical.com>  Thu, 28 Nov 2024 17:18:08 +0800
