=== debian/control ===
Source: ipu6-camera-hal
Section: libs
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 dh-modaliases,
 libdrm-dev,
 libexpat-dev,
 libipu6-dev (>= 0~git202309010954.376fccf~),
 libipu6ep-dev (>= 0~git202309010954.376fccf~),
 libipu6epmtl-dev (>= 0~git202309010954.376fccf~),
 pkg-config,
Standards-Version: 4.5.0
Maintainer: Commercial Engineering <commercial-engineering@canonical.com>
Vcs-Browser: https://github.com/intel/ipu6-camera-hal
Vcs-Git: https://github.com/intel/ipu6-camera-hal.git

Package: libcamhal0
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal-common (= ${source:Version}),
Breaks:
 libcamhal-ipu6ep0 (<= 0~git202309010954.7964af4~),
Replaces:
 libcamhal-ipu6ep0 (<= 0~git202309010954.7964af4~),
Recommends:
 gstreamer1.0-icamera, v4l2-relayd
Description: HAL library for MIPI camera through Intel IPU6
 This package contains the main runtime library on Intel IPU6 platform.

Package: libcamhal-common
Architecture: all
Depends:
 ${misc:Depends},
Breaks:
 libcamhal-ipu6ep-common (<= 0~git202309010954.7964af4~),
Replaces:
 libcamhal-ipu6ep-common (<= 0~git202309010954.7964af4~),
Description: HAL library for MIPI camera through Intel IPU6 - common files
 This package contains default camera settings on Intel IPU6 platform.

Package: libcamhal-dev
Architecture: any
Depends:
 ${misc:Depends},
 libcamhal0 (= ${binary:Version}),
 pkg-config,
Breaks:
 libcamhal-ipu6ep-dev (<= 0~git202309010954.7964af4~),
Replaces:
 libcamhal-ipu6ep-dev (<= 0~git202309010954.7964af4~),
Description: HAL library for MIPI camera through Intel IPU6 - development kit
 This package contains development files for libcamhal0 on Intel IPU6 platform.

Package: libcamhal-ipu6
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal0 (= ${binary:Version}),
 libcamhal-ipu6-common (= ${binary:Version}),
XB-Modaliases: ${modaliases}
Description: Dynamic loading plugin for IPU6 camera (ipu6)
 This package contains the main runtime library on Intel IPU6 platform.
 The HAL library will load this plugin at runtime.

Package: libcamhal-ipu6-common
Architecture: all
Depends: libcamhal-common (= ${binary:Version})
Description: Common files for for MIPI camera through Intel IPU6 (ipu6)
 This package contains default camera settings on Intel IPU6 platform.
 The physical camera needs the settings to be configured on the host.

Package: libcamhal-ipu6-dev
Architecture: any
Depends: libcamhal-dev (= ${binary:Version})
Description: Dynamic loading plugin for IPU6 camera (ipu6) - development kit
 This package contains development files for libcamhal-ipu6.

Package: libcamhal-ipu6ep
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal0 (= ${binary:Version}),
 libcamhal-ipu6ep-common (= ${binary:Version}),
XB-Modaliases: ${modaliases}
Description: Dynamic loading plugin for IPU6 camera (ipu6ep)
 This package contains the main runtime library on Intel IPU6 platform.
 The HAL library will load this plugin at runtime.

Package: libcamhal-ipu6ep-common
Architecture: all
Depends: libcamhal-common (= ${binary:Version})
Description: Common files for for MIPI camera through Intel IPU6 (ipu6ep)
 This package contains default camera settings on Intel IPU6 platform.
 The physical camera needs the settings to be configured on the host.

Package: libcamhal-ipu6ep-dev
Architecture: any
Depends: libcamhal-dev (= ${binary:Version})
Description: Dynamic loading plugin for IPU6 camera (ipu6ep) - development kit
 This package contains development files for libcamhal-ipu6ep.

Package: libcamhal-ipu6epmtl
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal0 (= ${binary:Version}),
 libcamhal-ipu6epmtl-common (= ${binary:Version}),
XB-Modaliases: ${modaliases}
Description: Dynamic loading plugin for IPU6 camera (ipu6epmtl)
 This package contains the main runtime library on Intel IPU6 platform.
 The HAL library will load this plugin at runtime.

Package: libcamhal-ipu6epmtl-common
Architecture: all
Depends: libcamhal-common (= ${binary:Version})
Description: Common files for for MIPI camera through Intel IPU6 (ipu6epmtl)
 This package contains default camera settings on Intel IPU6 platform.
 The physical camera needs the settings to be configured on the host.

Package: libcamhal-ipu6epmtl-dev
Architecture: any
Depends: libcamhal-dev (= ${binary:Version})
Description: Dynamic loading plugin for IPU6 camera (ipu6epmtl) - development kit
 This package contains development files for libcamhal-ipu6epmtl.
