=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

configure_args = \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INSTALL_LIBDIR=lib \
	-DBUILD_CAMHAL_ADAPTOR=ON \
	-DBUILD_CAMHAL_PLUGIN=ON \
	-DUSE_STATIC_GRAPH=ON \
	-DUSE_STATIC_GRAPH_AUTOGEN=ON \
	-DUSE_PG_LITE_PIPE=ON \
	$(empty)

targets = ipu6 ipu6ep ipu6epmtl
versions = "ipu6;ipu6ep;ipu6epmtl"

%:
	dh $@ --with modaliases

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build -- \
		-DIPU_VERSIONS=$(versions) $(configure_args); \

override_dh_auto_install:
	sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
		debian/libcamhal0.install.in > debian/libcamhal0.install
	sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
		debian/libcamhal-dev.install.in > debian/libcamhal-dev.install
	for ipu_ver in $(targets); do \
		sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
			debian/libcamhal-$${ipu_ver}-dev.install.in > debian/libcamhal-$${ipu_ver}-dev.install; \
	done
	dh_auto_install --builddirectory=build --destdir=debian/tmp

override_dh_auto_clean:
	dh_auto_clean --builddirectory=build
	rm -rf debian/tmp
