=== debian/changelog ===
ipu6-camera-hal (0~git202506270118.c933525~ubuntu24.04.4) noble; urgency=low

  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Mon, 13 Oct 2025 04:02:24 +0000
