=== debian/changelog ===
ipu6-camera-hal (0~git202506270118.c933525~ubuntu24.04.5) noble; urgency=low

  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Thu, 06 Nov 2025 09:52:50 +0000
